/* AMXMOD script.
*
* (c) Copyright 2000-2002, OLO
* This file is provided as is (no warranties).
*
*/

#include <amxmod> /* read this file to learn the functions */

public admin_kick(id)
{
	if (!(get_user_flags(id)&ADMIN_KICK))
	{
		client_print(id,print_console,"[AMX] You have no access to that command")
		return PLUGIN_HANDLED
	}

	if (read_argc() < 2)
	{
		client_print(id,print_console,"[AMX] Usage: amx_kick < part of nick >")
		return PLUGIN_HANDLED
	}

	new arg[32]
	read_argv(1,arg,32)
	new player = find_player("b",arg)

	if (player)
	{
		if (get_user_flags(player)&ADMIN_IMMUNITY)
		{
			client_print(id,print_console,"[AMX] The player has immunity")
			return PLUGIN_HANDLED
		}

		server_cmd("kick #%d",get_user_userid(player))
		new name[32]
		get_user_name(player,name,32)
		client_print(id,print_console,"[AMX] Client ^"%s^" kicked",name)
	}
	else
	{
		client_print(id,print_console,"[AMX] Client with that part of nick not found")
	}

	return PLUGIN_HANDLED
}

public admin_ban(id)
{
	if (!(get_user_flags(id)&ADMIN_BAN))
	{
		client_print(id,print_console,"[AMX] You have no access to that command")
		return PLUGIN_HANDLED
	}

	if (read_argc() < 3)
	{
		client_print(id,print_console,"[AMX] Usage: amx_ban < minutes > < part of nick >")
		return PLUGIN_HANDLED
	}

	new arg[32]
	read_argv(2,arg,32)
	new player = find_player("b",arg)

	if (player)
	{
		if (get_user_flags(player)&ADMIN_IMMUNITY)
		{
			client_print(id,print_console,"[AMX] The player has immunity")
			return PLUGIN_HANDLED
		}
		else if (is_user_bot(player))
		{
			client_print(id,print_console,"[AMX] Bot can't be banned")
			return PLUGIN_HANDLED
		}

		new minutes[32]
		read_argv(1,arg,32)
		new authid[32]
		get_user_authid(player,authid,32)
		server_cmd("ban %s %s kick",minutes,authid)
		new name[32]
		get_user_name(player,name,32)
		client_print(id,print_console,"[AMX] Client ^"%s^" banned",name)
	}
	else
	{
		client_print(id,print_console,"[AMX] Client with that part of nick not found")
	}

	return PLUGIN_HANDLED
}

public admin_slay(id)
{
	if (!(get_user_flags(id)&ADMIN_SLAY))
	{
		client_print(id,print_console,"[AMX] You have no access to that command")
		return PLUGIN_HANDLED
	}

	if (read_argc() < 2)
	{
		client_print(id,print_console,"[AMX] Usage: amx_slay < part of nick >")
		return PLUGIN_HANDLED
	}

	new arg[32]
	read_argv(1,arg,32)
	new player = find_player("b",arg)

	if (player)
	{
		if (get_user_flags(player)&ADMIN_IMMUNITY)
		{
			client_print(id,print_console,"[AMX] The player has immunity")
			return PLUGIN_HANDLED
		}

		user_kill(player)
		new name[32]
		get_user_name(player,name,32)
		client_print(id,print_console,"[AMX] Client ^"%s^" slayed",name)
	}
	else
	{
		client_print(id,print_console,"[AMX] Client with that part of nick not found")
	}

	return PLUGIN_HANDLED
}

public delayed_map(mapname[])
{
	server_cmd("changelevel %s",mapname)
}

public admin_map(id)
{
	if (!(get_user_flags(id) & ADMIN_CHANGELEVEL))
	{
		client_print(id,print_console,"[AMX] You have no access to that command")
		return PLUGIN_HANDLED
	}

	if (read_argc() < 2)
	{
		client_print(id,print_console,"[AMX] Usage: amx_map < mapname > [ delay in sec. ]")
		return PLUGIN_HANDLED
	}

	new arg[32]
	read_argv(1,arg,32)

	if (is_map_valid(arg)==0)
	{
		client_print(id,print_console,"[AMX] Map with that name not found or map is invalid")
		return PLUGIN_HANDLED
	}

	client_print(id,print_console,"[AMX] Changing map")

	if (read_argc() > 2)
	{
		message_begin(MSG_ALL, SVC_INTERMISSION)
		message_end()
		new arg2[32]
		read_argv(2,arg2,32)
		set_task( floatstr(arg2) ,"delayed_map",0,arg)
	}
	else 
	{
		set_task(0.5,"delayed_map",0,arg)
	}

	return PLUGIN_HANDLED
}

public admin_cvar(id)
{
	if (!(get_user_flags(id) & ADMIN_CVAR))
	{
		client_print(id,print_console,"[AMX] You have no access to that command")
		return PLUGIN_HANDLED
	}

	if (read_argc() < 3)
	{
		client_print(id,print_console,"[AMX] Usage: amx_cvar < cvar > < value >")
		return PLUGIN_HANDLED
	}

	new arg[32], arg2[64]
	read_argv(1,arg,32)
	read_argv(2,arg2,64)

	if (cvar_exists(arg))
	{
		if (equal(arg,"rcon_password") && !(get_user_flags(id) & ADMIN_CONSOLE))
		{
			client_print(id,print_console,"[AMX] You have no access to that cvar")
			return PLUGIN_HANDLED
		}

		set_cvar_string(arg,arg2);
		client_print(id,print_console,"[AMX] Cvar ^"%s^" changed to ^"%s^"",arg,arg2)
	}
	else
	{
		client_print(id,print_console,"[AMX] Unknown cvar")
	}

	return PLUGIN_HANDLED
}

public admin_cfg(id)
{
	if (!(get_user_flags(id) & ADMIN_CFG))
	{
		client_print(id,print_console,"[AMX] You have no access to that command")
		return PLUGIN_HANDLED
	}

	if (read_argc() < 2)
	{
		client_print(id,print_console,"[AMX] Usage: amx_cfg < fliename >")
		return PLUGIN_HANDLED
	}

	new arg[128]
	read_argv(1,arg,128)

	if (file_exists(arg))
	{
		client_print(id,print_console,"[AMX] Executing file ^"%s^"",arg)
		server_cmd("exec %s",arg)
	}
	else
	{
		client_print(id,print_console,"[AMX] File not found",arg)
	}

	return PLUGIN_HANDLED
}

public admin_rcon(id)
{
	if (!(get_user_flags(id) & ADMIN_CONSOLE))
	{
		client_print(id,print_console,"[AMX] You have no access to that command")
		return PLUGIN_HANDLED
	}

	if (read_argc() < 2)
	{
		client_print(id,print_console,"[AMX] Usage: amx_rcon < commad line >")
		return PLUGIN_HANDLED
	}

	new arg[128]
	read_args(arg,128)
	client_print(id,print_console,"[AMX] Commmand line ^"%s^" sent to server console",arg)
	server_cmd(arg)

	return PLUGIN_HANDLED
}

public admin_help(id)
{
	new flags = get_user_flags(id)

	if (flags == 0) {
		client_print(id,print_console,"^n[AMX] You are not logged as admin/privileges user")
		return PLUGIN_HANDLED
	}

	client_print(id,print_console,"^n[AMX] Your access level is: %d. You have %simmunity.^n^n[AMX] Commands:",
		flags, (flags&ADMIN_IMMUNITY)?"":"no " )

	if (flags  & ADMIN_SLAY) client_print(id,print_console,"[AMX] amx_slay < part of nick >")
	if (flags  & ADMIN_BAN) client_print(id,print_console,"[AMX] amx_ban < minutes > < part of nick >")
	if (flags  & ADMIN_KICK) client_print(id,print_console,"[AMX] amx_kick < part of nick >")
	if (flags  & ADMIN_CHANGELEVEL) client_print(id,print_console,"[AMX] amx_map < mapname > [ delay in sec. ]")
	if (flags  & ADMIN_CFG) client_print(id,print_console,"[AMX] amx_cfg < fliename >")
	if (flags  & ADMIN_CVAR) client_print(id,print_console,"[AMX] amx_cvar < cvar > < value >")
	if (flags  & ADMIN_CONSOLE) client_print(id,print_console,"[AMX] amx_rcon < commad line >")

	return PLUGIN_HANDLED
}

public plugin_init()
{
	register_plugin("ADMINCMD","0.4","-")

	register_clcmd("amx_kick","admin_kick")
	register_clcmd("amx_ban","admin_ban")
	register_clcmd("amx_slay","admin_slay")
	register_clcmd("amx_map","admin_map")
	register_clcmd("amx_cvar","admin_cvar")
	register_clcmd("amx_cfg","admin_cfg")
	register_clcmd("amx_rcon","admin_rcon")
	register_clcmd("amx_help","admin_help")

	return PLUGIN_CONTINUE
}
