/* AMXMOD script.
*
* (c) Copyright 2000-2002, OLO
* This file is provided as is (no warranties).
*
*/

#include <amxmod>

#define KICK_TIME	 	10.0

/*
* cvar: amx_mirrordmg < sum of bits below >
* 0 - disable mirror damage
* 1 - take health from attacked
* 2 - give lost health and armor to the victim
* 4 - make attacker glowing
* 8 - kick players attacking teammates at roundstart
*
*/

new damage_mode
new attacker[33]
new last_health[33]
new last_armor[33]
new Float:roundtime[33]
new glow[33]

public resethud_msg(id)
{
  	attacker[id] = 0
	last_health[id] = 0
	last_armor[id] = 0
	glow[id] = 0
	roundtime[id] = get_gametime() + get_cvar_float("mp_freezetime") + KICK_TIME
	user_glow(id)
}

public damage_msg(id)
{
	new enemy = get_user_attacker(id)
	if (get_user_team(id) == get_user_team(enemy))	attacker[id] = enemy
	return PLUGIN_CONTINUE
}

public glow_change(parm[])
{
	new id = str_to_num(parm)
	glow[id] -= 5
	if (glow[id] > 0) {
		user_glow(id,kRenderFxGlowShell,glow[id],0,0, kRenderNormal, 16)
		set_task(0.2,"glow_change",0,parm)
	}
	else {
		user_glow(id)
	}
}

public health_msg(id)
{
	new cur_health = get_user_health(id)
	new cur_armor = get_user_armor(id)
	new enemy = attacker[id]
	if ( enemy ) {
		new health_take = last_health[id] - cur_health
		new armor_take = last_armor[id] - cur_armor

		if ( damage_mode & 1 )	{
			set_user_health(enemy, get_user_health(enemy) - health_take )
			set_user_armor(enemy, get_user_armor(enemy) - armor_take )	
		}
		if ( damage_mode & 2 )	{
			set_user_health(id,cur_health = last_health[id])
			set_user_armor(id,cur_armor  = last_armor[id])
		}
		if ( damage_mode & 4 )	{
			if (glow[enemy] < 1)	{
				new parm[4]
				num_to_str(enemy,parm,4)
				set_task(0.2,"glow_change",0,parm)
			}
			glow[enemy] += 15
			user_glow(enemy,kRenderFxGlowShell,glow[enemy],0,0,kRenderNormal, 16)
		}
		if ( (damage_mode & 8) && (roundtime[enemy] > get_gametime()))
			client_cmd(enemy,"echo [AMX] Sorry but there is no place for such ppl as you;disconnect")
	}
	attacker[id] = 0
	last_health[id] = cur_health
	last_armor[id] = cur_armor
}

public damage_cvar()
{
	damage_mode = floatround(get_cvar_float("amx_mirrordmg"))
}

public plugin_init()
{
	register_plugin("MIRROR DAMAGE","0.4","OLO")

    	register_event("ResetHUD", "resethud_msg","b")
    	register_event("Health", "health_msg","b")
    	register_event("Damage", "damage_msg", "b", "2!0", "3=0", "4!0")

	register_cvar("amx_mirrordmg","5",0)
	set_task(5.0,"damage_cvar",0,"","b")

	return PLUGIN_CONTINUE
}
